﻿$uname addinsManager
$dname Менеджер скриптов Снегопата

Перем ЭтаФорма;
Перем ДобавлениеГруппы;

//////////////////////////////////////////////////////////////////////////
// макросы Снегопата

Процедура Макрос_ОткрытьНастройку() Экспорт
	
	КаталогСнегопата = Designer.profileRoot.getValue("Snegopat/MainFolder");
	ЭтаФорма = Designer.loadScriptForm(КаталогСнегопата + "\scripts\addinsMngr2.ssf", ЭтотОбъект);
	ЭтаФорма.Открыть();
	
КонецПроцедуры

//////////////////////////////////////////////////////////////////////////
// вспомогательные методы

Процедура ПрочитатьКаталог(Знач Каталог, Знач КоллекцияСтрок)
	
	ВсеФайлы = globalContext("{22A21030-E1D6-46A0-9465-F0A5427BE011}").НайтиФайлы(Каталог, "*.*" , Ложь);
	Количество = ВсеФайлы.Количество()-1;
	Для Сч = 0 По Количество Цикл
		
		Файл = ВсеФайлы.Получить(Сч);
		Если Файл.ЭтоКаталог() Тогда
			Стр = КоллекцияСтрок.Добавить();
			Стр.Имя = Файл.Имя;
			Стр.ПолноеИмя = Файл.ПолноеИмя;
			Стр.ЭтоГруппа = Истина;
			
			// фиктивная строка для динамического просмотра
			Фикт = Стр.Строки.Добавить();
			Фикт.ФиктивнаяСтрока = Истина;
			
		ИначеЕсли Не ПустаяСтрока(Файл.Расширение) и Найти(".js;.dll;.1scr", Файл.Расширение) > 0 Тогда
			Стр = КоллекцияСтрок.Добавить();
			Если Файл.Расширение <> ".dll" Тогда
				Имя = ПолучитьОтображаемоеИмя(Файл.ПолноеИмя);
				Если Имя = Неопределено Тогда
					Стр.Имя = Файл.Имя;
				Иначе
					Стр.Имя = Имя;
				КонецЕсли;
			Иначе
				Стр.Имя = Файл.Имя;
			КонецЕсли;
			
			Стр.ПолноеИмя = Файл.ПолноеИмя;
			Стр.ЭтоГруппа = Ложь;
		КонецЕсли;
		
	КонецЦикла;
	
	КоллекцияСтрок.Сортировать("ЭтоГруппа УБЫВ");
	
КонецПроцедуры

Процедура ПрочитатьИзбранное(Знач Каталог)
	
	Чтение = ОткрытьФайл(Каталог + "\addins.ini");
	Попытка
		ЗаполнитьГруппу(ЭтаФорма.ДеревоВыбранных.Строки, Каталог, Чтение);
	Исключение
		MessageBox(ИнформацияОбОшибке().Описание);
	КонецПопытки;
	
	Чтение.Закрыть();
	Чтение = Неопределено;
	
КонецПроцедуры

Процедура ЗаполнитьГруппу(Знач ТекущаяКоллекция, Знач Каталог, Чтение)
	
	Пока Истина Цикл
		
		СтрокаФайла = Чтение.ПрочитатьСтроку();
		Если СтрокаФайла = Неопределено Тогда
			Прервать;
		КонецЕсли;
		
		Если ПустаяСтрока(СтрокаФайла) Тогда
			Продолжить;
		КонецЕсли;
		
		Если НРег(Лев(СтрокаФайла, 6)) = "группа" Тогда
			ИмяГруппы = Сред(СтрокаФайла, 7);
			СтрокаГруппы = ТекущаяКоллекция.Добавить();
			СтрокаГруппы.Имя = ИмяГруппы;
			СтрокаГруппы.ЭтоГруппа = Истина;
			ЗаполнитьГруппу(СтрокаГруппы.Строки, Каталог, Чтение);
		ИначеЕсли НРег(Лев(СтрокаФайла,11)) = "конецгруппы" Тогда
			Возврат;
		Иначе
			
			ПозицияПротокола = Найти(СтрокаФайла, ":");
			Если ПозицияПротокола = 0 Тогда
				Продолжить;
			КонецЕсли;
			
			Протокол = НРег(Лев(СтрокаФайла, ПозицияПротокола-1));
			Путь = Сред(СтрокаФайла, ПозицияПротокола+1);
			Если Не (Лев(Путь,2) = "\\" или Найти(Путь, ":") > 0) Тогда
				Путь = Каталог + Путь;
			КонецЕсли;
			
			Если Протокол = "script" или Протокол = "1clang" Тогда
				НоваяСтрока = ДобавитьСкриптВДерево(Путь, ТекущаяКоллекция);
				НоваяСтрока.СтрокаПодключения = Лев(СтрокаФайла, ПозицияПротокола) + Путь;
				НоваяСтрока.ПолноеИмя = Путь;
			Иначе
				НоваяСтрока = ТекущаяКоллекция.Добавить();
				НоваяСтрока.СтрокаПодключения = Лев(СтрокаФайла, ПозицияПротокола) + Путь;
				НоваяСтрока.ПолноеИмя = Путь;
				
				Файл = v8new("Файл", Путь);
				НоваяСтрока.Имя = Файл.Имя;
				Файл = Неопределено;
				
			КонецЕсли;
			
			НоваяСтрока.ЭтоГруппа = Ложь;
			
		КонецЕсли;
		
	КонецЦикла;
	
КонецПроцедуры

Процедура ЗаписатьГруппу(Знач ТекущаяКоллекция, Знач Запись)
	
	Для Каждого Строка Из ТекущаяКоллекция Цикл
		Если Не Строка.ЭтоГруппа Тогда
			Запись.ЗаписатьСтроку(Строка.СтрокаПодключения);
		Иначе
			Запись.ЗаписатьСтроку("Группа " + Строка.Имя);
			ЗаписатьГруппу(Строка.Строки, Запись);
			Запись.ЗаписатьСтроку("КонецГруппы");
		КонецЕсли;
	КонецЦикла;
	
КонецПроцедуры

Функция ДобавитьСкриптВДерево(Знач Путь, Знач Коллекция)
	
	Имя = ПолучитьОтображаемоеИмя(Путь);
	Если Имя = Неопределено Тогда
		Файл = v8new("Файл", Путь);
		Имя = Файл.Имя;
		Файл = Неопределено;
	КонецЕсли;
	
	Стр = Коллекция.Добавить();
	Стр.Имя = Имя;
	Стр.ПолноеИмя = Путь;
	
	Возврат Стр;
	
КонецФункции

Функция ПолучитьОтображаемоеИмя(Знач Путь)
	
	Чтение = ОткрытьФайл(Путь);
	Попытка	
		Пока Истина Цикл
			
			СтрокаТекста = Чтение.ПрочитатьСтроку();
			Если СтрокаТекста = Неопределено Тогда
				Чтение.Закрыть();
				Возврат Неопределено;
			КонецЕсли;
			
			Если ПустаяСтрока(СтрокаТекста) Тогда
				Продолжить;
			КонецЕсли;
			
			Если Лев(СтрокаТекста,1) = "$" Тогда
				Если Лев(СтрокаТекста, 6) = "$dname" Тогда
					Чтение.Закрыть();
					ОтображаемоеИмя = Сред(СтрокаТекста, 7);
					Если Не ПустаяСтрока(ОтображаемоеИмя) Тогда
						Возврат ОтображаемоеИмя;
					Иначе
						Возврат Неопределено;
					КонецЕсли;
				КонецЕсли;
			Иначе
				Чтение.Закрыть();
				Возврат Неопределено;
			КонецЕсли;
			
		КонецЦикла;

	Исключение
		Чтение.Закрыть();
		Возврат Неопределено;
	КонецПопытки;
	
КонецФункции

Функция ОткрытьФайл(Знач Путь)

	Возврат v8new("ЧтениеТекста", Путь);

КонецФункции

Процедура ПриПолученииДанных(Элемент, ОформленияСтрок)
	
	Граница = ОформленияСтрок.Количество()-1;
	Для Сч = 0 По Граница Цикл
		
		Оформление = ОформленияСтрок.Получить(Сч);
		Оформление.Ячейки.Имя.ОтображатьКартинку = Истина;
		Если Не Оформление.ДанныеСтроки.ЭтоГруппа = Истина Тогда
			Оформление.Ячейки.Имя.ИндексКартинки = 1;
		Иначе
			Оформление.Ячейки.Имя.ИндексКартинки = 0;
		КонецЕсли;
		
	КонецЦикла;
	
КонецПроцедуры

Функция ИмяРезервнойКопии(Знач Каталог, Знач ИсходноеИмя, Знач Счетчик)
	
	ТекФайл   = v8new("Файл", Каталог + "\" + ИсходноеИмя);
	НовоеИмя  = ТекФайл.ИмяБезРасширения + ?(Счетчик = 0,""," [" + Строка(Счетчик) + "]") + ТекФайл.Расширение;
	
	НовыйФайл = v8new("Файл", Каталог + "\" + НовоеИмя);
	
	Если НовыйФайл.Существует() Тогда
		Возврат ИмяРезервнойКопии(Каталог,ИсходноеИмя,Счетчик + 1);
	Иначе
		Возврат НовыйФайл.ПолноеИмя;
	КонецЕсли;
	
КонецФункции

Процедура ПеренестиИзИсточникаВПриемник(Знач СтрокаИсточник, Знач КоллекцияПриемник)
	
	Стр = КоллекцияПриемник.Добавить();
	Стр.Имя = СтрокаИсточник.Имя;
	Стр.ПолноеИмя = СтрокаИсточник.ПолноеИмя;
	Стр.ЭтоГруппа = Ложь;
	
	Файл = v8new("Файл", Стр.ПолноеИмя);
	Если Файл.Расширение = ".js" Тогда
		Протокол = "script:";
	ИначеЕсли Файл.Расширение = ".1scr" Тогда
		Протокол = "1clang:";
	ИначеЕсли Файл.Расширение = ".dll" Тогда
		Протокол = "dll:";
	Иначе
		Протокол = "unknown:";
	КонецЕсли;
	
	Стр.СтрокаПодключения = Протокол + Стр.ПолноеИмя;
	
КонецПроцедуры

Функция КоллекцияПриемникИзбранного()
	Приемник = ЭтаФорма.ЭлементыФормы.ДеревоВыбранных.ТекущиеДанные;
	Если Приемник = Неопределено Тогда
		Коллекция = ЭтаФорма.ДеревоВыбранных.Строки;
	Иначе
		Если Приемник.ЭтоГруппа Тогда
			Коллекция = Приемник.Строки;
		Иначе
			Родитель = Приемник.Родитель;
			Если Родитель = Неопределено Тогда
				Коллекция = ЭтаФорма.ДеревоВыбранных.Строки;
			Иначе
				Коллекция = Родитель.Строки;
			КонецЕсли;
		КонецЕсли;
	КонецЕсли;
	
	Возврат Коллекция;
	
КонецФункции

Процедура ОткрытьФайлСкрипта(Знач Путь)
	
	ТД = v8new("ТекстовыйДокумент");
	ТД.Прочитать(Путь);
	ТД.Показать();
	
КонецПроцедуры

Процедура ПерегрузитьAddinsIni(Знач ФайлНастроек, Знач ЭтотФайл)
	
	Чтение = ОткрытьФайл(ФайлНастроек);
	Попытка
		
		Пока Истина Цикл
			СтрокаТекста = Чтение.ПрочитатьСтроку();
			Message(СтрокаТекста);
			
			Если СтрокаТекста = Неопределено Тогда
				Прервать;
			КонецЕсли;
			
			Если ПустаяСтрока(СтрокаТекста) или Лев(СтрокаТекста,1) = "#" 
				 или НРег(Лев(СтрокаТекста, 6)) = "группа" или НРег(Лев(СтрокаТекста,11)) = "конецгруппы" Тогда
				Продолжить;
			КонецЕсли;
			
			// самого себя выгружать не будем.
			Если Нрег(СтрокаТекста) = НРег(ЭтотФайл) Тогда
				Продолжить;
			КонецЕсли;
			
			Плагин = addins.byFullPath(СтрокаТекста);
			Группа = addins.root.child.next.next;
			Если Плагин = Неопределено Тогда
				addins.loadAddin(СтрокаТекста, Группа);
			ИначеЕсли addins.isAddinUnloadable(Плагин) Тогда
				addins.unloadAddin(Плагин);
				addins.loadAddin(СтрокаТекста, Группа);
			КонецЕсли;
			
		КонецЦикла;
		
		Чтение.Закрыть();
		Чтение = Неопределено;
		
	Исключение
		Чтение.Закрыть();
		Чтение = Неопределено;
		ВызватьИсключение;
	КонецПопытки;
	
КонецПроцедуры


//////////////////////////////////////////////////////////////////////////
// обработчики событий формы

Процедура КоманднаяПанельФормыСохранить(Кнопка) Экспорт
	
	КаталогСнегопата = Designer.profileRoot.getValue("Snegopat/MainFolder");
	ФайлНастроек = КаталогСнегопата + "\addins.ini";
	
	РезервнаяКопия = ИмяРезервнойКопии(КаталогСнегопата, "addins.ini", 0);
	
	globalContext("{22A21030-E1D6-46A0-9465-F0A5427BE011}").КопироватьФайл(ФайлНастроек, РезервнаяКопия);
	
	Запись = v8new("ЗаписьТекста", ФайлНастроек);
	Попытка
		ЗаписатьГруппу(ЭтаФорма.ДеревоВыбранных.Строки, Запись);
	Исключение
		Запись.Закрыть();
		ВызватьИсключение;
	КонецПопытки;
		
	Запись.Закрыть();
	Запись = Неопределено;
	Результат = MessageBox("Файл addins.ini обновлен. Перезагрузить аддины?", 4);
	Если Результат = 6 Тогда
		
		ЭтотФайл = "1clang:" + КаталогСнегопата + "\scripts\addinsMngr2.1scr";
		Попытка
			ПерегрузитьAddinsIni(ФайлНастроек, ЭтотФайл);
		Исключение
			Message(ИнформацияОбОшибке().Описание);
		КонецПопытки;
		
	КонецЕсли;
	
КонецПроцедуры

Процедура КоманднаяПанель1ДобавитьВИзбранное(Кнопка) Экспорт
	
	Если ЭтаФорма.ЭлементыФормы.ДеревоФайлов.ВыделенныеСтроки.Количество() = 0 Тогда
		MessageBox("Выберите строку источника");
		Возврат;
	КонецЕсли;
	
	Коллекция = КоллекцияПриемникИзбранного();
	
	МассивСтрок = v8new("Массив");
	ОбработанныеСтроки = v8new("Соответствие");
	Для каждого СтрокаИсточник Из ЭтаФорма.ЭлементыФормы.ДеревоФайлов.ВыделенныеСтроки Цикл
		МассивСтрок.Добавить(СтрокаИсточник);
	КонецЦикла;
	
	Для каждого СтрокаИсточник Из МассивСтрок Цикл
		Если Не СтрокаИсточник.ЭтоГруппа и ОбработанныеСтроки.Получить(СтрокаИсточник) = Неопределено Тогда
			ПеренестиИзИсточникаВПриемник(СтрокаИсточник, Коллекция);
			ОбработанныеСтроки.Вставить(СтрокаИсточник, Истина);
		КонецЕсли;
	КонецЦикла;
	
	Для каждого КлючИЗначение Из ОбработанныеСтроки Цикл
		
		СтрокаИсточник = КлючИЗначение.Ключ;
		Родитель = СтрокаИсточник.Родитель;
		Если Родитель = Неопределено Тогда
			ЭтаФорма.ДеревоФайлов.Строки.Удалить(СтрокаИсточник);
		Иначе
			Родитель.Строки.Удалить(СтрокаИсточник);
		КонецЕсли;
		
	КонецЦикла;
	
КонецПроцедуры

Процедура КоманднаяПанель1УбратьИзИзбранного(Кнопка) Экспорт
	
	ТекСтрока = ЭтаФорма.ЭлементыФормы.ДеревоВыбранных.ТекущиеДанные;
	Если ТекСтрока <> Неопределено Тогда
		Родитель = ТекСтрока.Родитель;
		Если Родитель = Неопределено Тогда
			ЭтаФорма.ДеревоВыбранных.Строки.Удалить(ТекСтрока);
		Иначе
			Родитель.Строки.Удалить(ТекСтрока);
		КонецЕсли;
	КонецЕсли;
	
КонецПроцедуры

Процедура КоманднаяПанельВыбранныхДобавитьГруппу(Кнопка) Экспорт
	
	КоллекцияПриемник = КоллекцияПриемникИзбранного();
	СтрокаГруппы = КоллекцияПриемник.Добавить();
	СтрокаГруппы.ЭтоГруппа = Истина;
	СтрокаГруппы.Имя = "Новая группа";
	
	ЭтаФорма.ЭлементыФормы.ДеревоВыбранных.ТекущаяСтрока = СтрокаГруппы;
	ЭтаФорма.ЭлементыФормы.ДеревоВыбранных.ИзменитьСтроку();
	
КонецПроцедуры

Процедура ДеревоВыбранныхПередНачаломДобавления(Элемент, Отказ, Копирование, Родитель) Экспорт
	Если ДобавлениеГруппы <> Истина Тогда
		Отказ = Истина;
	Иначе
		ДобавлениеГруппы = Ложь;
	КонецЕсли;
КонецПроцедуры

Процедура ДеревоВыбранныхПередНачаломИзменения(Элемент, Отказ) Экспорт
	
	ТекДанные = Элемент.ТекущиеДанные;
	Если ТекДанные.ЭтоГруппа <> Истина Тогда
		Отказ = Истина;
	КонецЕсли;
	
КонецПроцедуры

Процедура КаталогСкриптовПриИзменении(Элемент) Экспорт
	ЭтаФорма.ДеревоФайлов.Строки.Очистить();
	ПрочитатьКаталог(Элемент.Значение, ЭтаФорма.ДеревоФайлов.Строки);
КонецПроцедуры

Процедура ДеревоФайловВыбор(Элемент, ВыбраннаяСтрока, Колонка, СтандартнаяОбработка) Экспорт
	СтандартнаяОбработка = Ложь;
	Коллекция = КоллекцияПриемникИзбранного();
	ПеренестиИзИсточникаВПриемник(ВыбраннаяСтрока, Коллекция);
	
	Родитель = ВыбраннаяСтрока.Родитель;
	Если Родитель = Неопределено Тогда
		ЭтаФорма.ДеревоФайлов.Строки.Удалить(ВыбраннаяСтрока);
	Иначе
		Родитель.Строки.Удалить(ВыбраннаяСтрока);
	КонецЕсли;
	
КонецПроцедуры

Процедура ПриОткрытии() Экспорт
	
	КаталогСнегопата = Designer.profileRoot.getValue("Snegopat/MainFolder");
	ЭтаФорма.КаталогСкриптов = КаталогСнегопата + "scripts";
	ПрочитатьКаталог(ЭтаФорма.КаталогСкриптов, ЭтаФорма.ДеревоФайлов.Строки);
	ПрочитатьИзбранное(КаталогСнегопата);
	
КонецПроцедуры

Процедура ПриЗакрытии() Экспорт
	ЭтаФорма = Неопределено;
КонецПроцедуры

Процедура ДеревоФайловПередРазворачиванием(Элемент, Строка, Отказ) Экспорт
	
	Если Строка.Строки.Количество() = 1 и Строка.Строки.Получить(0).ФиктивнаяСтрока Тогда
		Строка.Строки.Удалить(0);
		ПрочитатьКаталог(Строка.ПолноеИмя, Строка.Строки);
	КонецЕсли;
	
КонецПроцедуры

Процедура ДеревоФайловПриПолученииДанных(Элемент, ОформленияСтрок) Экспорт
	
	ПриПолученииДанных(Элемент, ОформленияСтрок);
	
КонецПроцедуры

Процедура ДеревоВыбранныхПриПолученииДанных(Элемент, ОформленияСтрок) Экспорт
	
	ПриПолученииДанных(Элемент, ОформленияСтрок);
	
КонецПроцедуры

Процедура КонтекстноеМенюФайловОткрытьФайлСкрипта(Кнопка) Экспорт
	
	ТекДанные = ЭтаФорма.ЭлементыФормы.ДеревоФайлов.ТекущиеДанные;
	Если ТекДанные = Неопределено или ТекДанные.ЭтоГруппа Тогда
		Возврат;
	КонецЕсли;
	
	ОткрытьФайлСкрипта(ТекДанные.ПолноеИмя);
	
КонецПроцедуры

Процедура ДеревоВыбранныхВыбор(Элемент, ВыбраннаяСтрока, Колонка, СтандартнаяОбработка) Экспорт
	
	Если Не ВыбраннаяСтрока.ЭтоГруппа Тогда
		ОткрытьФайлСкрипта(ВыбраннаяСтрока.ПолноеИмя);
	КонецЕсли;
	
КонецПроцедуры

Процедура КонтекстноеМенюФайловПоказатьСправку(Кнопка) Экспорт
	
	ТекДанные = ЭтаФорма.ЭлементыФормы.ДеревоФайлов.ТекущиеДанные;
	Если ТекДанные = Неопределено или ТекДанные.ЭтоГруппа Тогда
		Возврат;
	КонецЕсли;
	
	КаталогСнегопата = Designer.profileRoot.getValue("Snegopat/MainFolder");
	КаталогСкриптов = КаталогСнегопата + "scripts\";
	Файл = v8new("Файл", ТекДанные.ПолноеИмя);
	Если НРег(Файл.Путь) = НРег(КаталогСкриптов) Тогда
		Аргумент = Файл.Имя;
	Иначе
		Подкаталог = v8new("Файл", Файл.Путь);
		Аргумент = Подкаталог.Имя + "/" + Файл.Имя;
	КонецЕсли;
	
	shell = Новый COMОбъект("WScript.Shell");
	shell.Run("https://snegopat.ru/scripts/wiki?name=" + Аргумент);
	
КонецПроцедуры
